#!/usr/bin/perl
# author: Fuyuncat
# Site:   WWW.HelloDBA.COM
# Script: http://www.Hellodba.com/Download/bloomfilter.zip
# Purpose: to simulate the bloom filter.

#use strict;
#use warnings;
use POSIX;

sub round {
    my($number) = shift;
    return int($number + .5);
}

#using mod as a simple hash function
sub hash_func {
    my $x = ((($_[0]<<$_[1])^($_[0]>>ceil($_[1]/2)))%$_[2]);
#print $x.",";
    return $x;
}

sub bloomFilter{
    my $k = $_[0];
    my $m = $_[1];
    my $value = $_[2];
    my @av=();
    my @kv=();

    for ($i=0;$i<$m;$i++) {
        $av[$i]=0;
        $kv[$i]=0;
    }

#print "vector:";
    for ($i=0;$i<@array.count;$i++) {
        for ($j=1;$j<=$k;$j++) {
            $av[hash_func($array[$i],$j,$m)]=1;
        }
    }
#print "\n";

#print "key mapping:";
    for ($j=1;$j<=$k;$j++) {
        $kv[hash_func($value,$j,$m)]=1;
    }
#print "\n";

    for ($i=0;$i<$m;$i++) {
        if ($kv[$i]==1 && $av[$i]==0) {
            return 0;
        }
    }
    return 1;
}

my $k = $ARGV[0];
my $m = $ARGV[1];

my $chknum = 100;
my $missed = 0;

my $arrsize = 20;

for ($a=0;$a<$chknum;$a++) {
    # initialize a random array
    @array=();
    $array[0]=floor(rand(100));
#    print "Random Array: ".$array[0];
    for ($i=1;$i<$arrsize;$i++) {
      $array[$i]=$array[$i-1]+1+floor(rand(100));
#      print ",".$array[$i];
    }
#    print "\n";

    my $value = floor(rand(1000));
    if (bloomFilter($k, $m, $value)==1) {
#        print $value." in the array\n";
        $bloomfiler=1;
    }
    else{
#        print $value." Not in the array\n";
        $bloomfiler=0;
    }

    #check if false positives
    $actualfilter = 0;
    for ($i=1;$i<$arrsize;$i++) {
        if (($value==$array[$i])) {
            $actualfilter = 1;
        }
    }
    if ($actualfilter != $bloomfiler) {
        $missed++;
    }

}

print "array size:".$arrsize."; hash num:".$k."; vector members:".$m."\n".$missed." missed in ".$chknum."(".(round($missed/$chknum*100)/100).")\n"
